# -*- coding: utf-8 -*-

"""
paypalrestapis

This file was automatically generated by APIMATIC v3.0 (
 https://www.apimatic.io ).
"""

from paypalrestapis.api_helper import APIHelper
from paypalrestapis.exceptions.api_exception import APIException
from paypalrestapis.models.error_details import ErrorDetails
from paypalrestapis.models.link_description import LinkDescription


class ErrorException(APIException):
    def __init__(self, reason, response):
        """Constructor for the ErrorException class

        Args:
            reason (string): The reason (or error message) for the Exception
                to be raised.
            response (HttpResponse): The HttpResponse of the API call.

        """
        super(ErrorException, self).__init__(reason, response)
        dictionary = APIHelper.json_deserialize(self.response.text)
        if isinstance(dictionary, dict):
            self.unbox(dictionary)

    def unbox(self, dictionary):
        """Populates the properties of this object by extracting them from a dictionary.

        Args:
            dictionary (dictionary): A dictionary representation of the object as
            obtained from the deserialization of the server's response. The keys
            MUST match property names in the API description.

        """
        self.name = dictionary.get("name") if dictionary.get("name") else None
        self.message = dictionary.get("message") if dictionary.get("message") else None
        self.debug_id = dictionary.get("debug_id") if dictionary.get("debug_id") else None
        self.details = None
        if dictionary.get('details') is not None:
            self.details = [ErrorDetails.from_dictionary(x) for x in dictionary.get('details')]
        else:
            self.details = None
        self.links = None
        if dictionary.get('links') is not None:
            self.links = [LinkDescription.from_dictionary(x) for x in dictionary.get('links')]
        else:
            self.links = None

    def __str__(self):
        base_str = super().__str__()
        return (f'{self.__class__.__name__}('
                f'{base_str[base_str.find("(") + 1:-1]}, '
                f'name={self.name!s}, '
                f'message={self.message!s}, '
                f'debug_id={self.debug_id!s}, '
                f'details={(self.details if hasattr(self, "details") else None)!s}, '
                f'links={(self.links if hasattr(self, "links") else None)!s})')
