# -*- coding: utf-8 -*-

"""
paypalrestapis

This file was automatically generated by APIMATIC v3.0 (
 https://www.apimatic.io ).
"""
from paypalrestapis.api_helper import APIHelper
from paypalrestapis.models.card_verification import CardVerification


class GooglePayCardAttributes(object):

    """Implementation of the 'Google Pay Card Attributes' model.

    Additional attributes associated with the use of this card.

    Attributes:
        verification (CardVerification): The API caller can opt in to verify
            the card through PayPal offered verification services (e.g. Smart
            Dollar Auth, 3DS).

    """

    # Create a mapping from Model property names to API property names
    _names = {
        "verification": 'verification'
    }

    _optionals = [
        'verification',
    ]

    def __init__(self,
                 verification=APIHelper.SKIP):
        """Constructor for the GooglePayCardAttributes class"""

        # Initialize members of the class
        if verification is not APIHelper.SKIP:
            self.verification = verification 

    @classmethod
    def from_dictionary(cls,
                        dictionary):
        """Creates an instance of this model from a dictionary

        Args:
            dictionary (dictionary): A dictionary representation of the object
            as obtained from the deserialization of the server's response. The
            keys MUST match property names in the API description.

        Returns:
            object: An instance of this structure class.

        """

        if not isinstance(dictionary, dict) or dictionary is None:
            return None

        # Extract variables from the dictionary
        verification = CardVerification.from_dictionary(dictionary.get('verification')) if 'verification' in dictionary.keys() else APIHelper.SKIP
        # Return an object of this model
        return cls(verification)

    def __repr__(self):
        return (f'{self.__class__.__name__}('
                f'verification={(self.verification if hasattr(self, "verification") else None)!r})')

    def __str__(self):
        return (f'{self.__class__.__name__}('
                f'verification={(self.verification if hasattr(self, "verification") else None)!s})')
