# -*- coding: utf-8 -*-

"""
paypalrestapis

This file was automatically generated by APIMATIC v3.0 (
 https://www.apimatic.io ).
"""
from paypalrestapis.api_helper import APIHelper
from paypalrestapis.models.money import Money
from paypalrestapis.models.universal_product_code import UniversalProductCode


class LineItem(object):

    """Implementation of the 'Line Item' model.

    The line items for this purchase. If your merchant account has been
    configured for Level 3 processing this field will be passed to the
    processor on your behalf.

    Attributes:
        name (str): The item name or title.
        unit_amount (Money): The currency and amount for a financial
            transaction, such as a balance or payment due.
        tax (Money): The currency and amount for a financial transaction, such
            as a balance or payment due.
        quantity (str): The item quantity. Must be a whole number.
        description (str): The detailed item description.
        sku (str): The stock keeping unit (SKU) for the item.
        url (str): The URL to the item being purchased. Visible to buyer and
            used in buyer experiences.
        image_url (str): The URL of the item's image. File type and size
            restrictions apply. An image that violates these restrictions will
            not be honored.
        upc (UniversalProductCode): The Universal Product Code of the item.
        commodity_code (str): Code used to classify items purchased and track
            the total amount spent across various categories of products and
            services. Different corporate purchasing organizations may use
            different standards, but the United Nations Standard Products and
            Services Code (UNSPSC) is frequently used.
        discount_amount (Money): The currency and amount for a financial
            transaction, such as a balance or payment due.
        total_amount (Money): The currency and amount for a financial
            transaction, such as a balance or payment due.
        unit_of_measure (str): Unit of measure is a standard used to express
            the magnitude of a quantity in international trade. Most commonly
            used (but not limited to) examples are: Acre (ACR), Ampere (AMP),
            Centigram (CGM), Centimetre (CMT), Cubic inch (INQ), Cubic metre
            (MTQ), Fluid ounce (OZA), Foot (FOT), Hour (HUR), Item (ITM),
            Kilogram (KGM), Kilometre (KMT), Kilowatt (KWT), Liquid gallon
            (GLL), Liter (LTR), Pounds (LBS), Square foot (FTK).

    """

    # Create a mapping from Model property names to API property names
    _names = {
        "name": 'name',
        "unit_amount": 'unit_amount',
        "quantity": 'quantity',
        "tax": 'tax',
        "description": 'description',
        "sku": 'sku',
        "url": 'url',
        "image_url": 'image_url',
        "upc": 'upc',
        "commodity_code": 'commodity_code',
        "discount_amount": 'discount_amount',
        "total_amount": 'total_amount',
        "unit_of_measure": 'unit_of_measure'
    }

    _optionals = [
        'tax',
        'description',
        'sku',
        'url',
        'image_url',
        'upc',
        'commodity_code',
        'discount_amount',
        'total_amount',
        'unit_of_measure',
    ]

    def __init__(self,
                 name=None,
                 unit_amount=None,
                 quantity=None,
                 tax=APIHelper.SKIP,
                 description=APIHelper.SKIP,
                 sku=APIHelper.SKIP,
                 url=APIHelper.SKIP,
                 image_url=APIHelper.SKIP,
                 upc=APIHelper.SKIP,
                 commodity_code=APIHelper.SKIP,
                 discount_amount=APIHelper.SKIP,
                 total_amount=APIHelper.SKIP,
                 unit_of_measure=APIHelper.SKIP):
        """Constructor for the LineItem class"""

        # Initialize members of the class
        self.name = name 
        self.unit_amount = unit_amount 
        if tax is not APIHelper.SKIP:
            self.tax = tax 
        self.quantity = quantity 
        if description is not APIHelper.SKIP:
            self.description = description 
        if sku is not APIHelper.SKIP:
            self.sku = sku 
        if url is not APIHelper.SKIP:
            self.url = url 
        if image_url is not APIHelper.SKIP:
            self.image_url = image_url 
        if upc is not APIHelper.SKIP:
            self.upc = upc 
        if commodity_code is not APIHelper.SKIP:
            self.commodity_code = commodity_code 
        if discount_amount is not APIHelper.SKIP:
            self.discount_amount = discount_amount 
        if total_amount is not APIHelper.SKIP:
            self.total_amount = total_amount 
        if unit_of_measure is not APIHelper.SKIP:
            self.unit_of_measure = unit_of_measure 

    @classmethod
    def from_dictionary(cls,
                        dictionary):
        """Creates an instance of this model from a dictionary

        Args:
            dictionary (dictionary): A dictionary representation of the object
            as obtained from the deserialization of the server's response. The
            keys MUST match property names in the API description.

        Returns:
            object: An instance of this structure class.

        """

        if not isinstance(dictionary, dict) or dictionary is None:
            return None

        # Extract variables from the dictionary
        name = dictionary.get("name") if dictionary.get("name") else None
        unit_amount = Money.from_dictionary(dictionary.get('unit_amount')) if dictionary.get('unit_amount') else None
        quantity = dictionary.get("quantity") if dictionary.get("quantity") else None
        tax = Money.from_dictionary(dictionary.get('tax')) if 'tax' in dictionary.keys() else APIHelper.SKIP
        description = dictionary.get("description") if dictionary.get("description") else APIHelper.SKIP
        sku = dictionary.get("sku") if dictionary.get("sku") else APIHelper.SKIP
        url = dictionary.get("url") if dictionary.get("url") else APIHelper.SKIP
        image_url = dictionary.get("image_url") if dictionary.get("image_url") else APIHelper.SKIP
        upc = UniversalProductCode.from_dictionary(dictionary.get('upc')) if 'upc' in dictionary.keys() else APIHelper.SKIP
        commodity_code = dictionary.get("commodity_code") if dictionary.get("commodity_code") else APIHelper.SKIP
        discount_amount = Money.from_dictionary(dictionary.get('discount_amount')) if 'discount_amount' in dictionary.keys() else APIHelper.SKIP
        total_amount = Money.from_dictionary(dictionary.get('total_amount')) if 'total_amount' in dictionary.keys() else APIHelper.SKIP
        unit_of_measure = dictionary.get("unit_of_measure") if dictionary.get("unit_of_measure") else APIHelper.SKIP
        # Return an object of this model
        return cls(name,
                   unit_amount,
                   quantity,
                   tax,
                   description,
                   sku,
                   url,
                   image_url,
                   upc,
                   commodity_code,
                   discount_amount,
                   total_amount,
                   unit_of_measure)

    def __repr__(self):
        return (f'{self.__class__.__name__}('
                f'name={self.name!r}, '
                f'unit_amount={self.unit_amount!r}, '
                f'tax={(self.tax if hasattr(self, "tax") else None)!r}, '
                f'quantity={self.quantity!r}, '
                f'description={(self.description if hasattr(self, "description") else None)!r}, '
                f'sku={(self.sku if hasattr(self, "sku") else None)!r}, '
                f'url={(self.url if hasattr(self, "url") else None)!r}, '
                f'image_url={(self.image_url if hasattr(self, "image_url") else None)!r}, '
                f'upc={(self.upc if hasattr(self, "upc") else None)!r}, '
                f'commodity_code={(self.commodity_code if hasattr(self, "commodity_code") else None)!r}, '
                f'discount_amount={(self.discount_amount if hasattr(self, "discount_amount") else None)!r}, '
                f'total_amount={(self.total_amount if hasattr(self, "total_amount") else None)!r}, '
                f'unit_of_measure={(self.unit_of_measure if hasattr(self, "unit_of_measure") else None)!r})')

    def __str__(self):
        return (f'{self.__class__.__name__}('
                f'name={self.name!s}, '
                f'unit_amount={self.unit_amount!s}, '
                f'tax={(self.tax if hasattr(self, "tax") else None)!s}, '
                f'quantity={self.quantity!s}, '
                f'description={(self.description if hasattr(self, "description") else None)!s}, '
                f'sku={(self.sku if hasattr(self, "sku") else None)!s}, '
                f'url={(self.url if hasattr(self, "url") else None)!s}, '
                f'image_url={(self.image_url if hasattr(self, "image_url") else None)!s}, '
                f'upc={(self.upc if hasattr(self, "upc") else None)!s}, '
                f'commodity_code={(self.commodity_code if hasattr(self, "commodity_code") else None)!s}, '
                f'discount_amount={(self.discount_amount if hasattr(self, "discount_amount") else None)!s}, '
                f'total_amount={(self.total_amount if hasattr(self, "total_amount") else None)!s}, '
                f'unit_of_measure={(self.unit_of_measure if hasattr(self, "unit_of_measure") else None)!s})')
