# -*- coding: utf-8 -*-

"""
paypalrestapis

This file was automatically generated by APIMATIC v3.0 (
 https://www.apimatic.io ).
"""
from paypalrestapis.api_helper import APIHelper


class RelatedIdentifiers(object):

    """Implementation of the 'Related Identifiers' model.

    Identifiers related to a specific resource.

    Attributes:
        order_id (str): Order ID related to the resource.
        authorization_id (str): Authorization ID related to the resource.
        capture_id (str): Capture ID related to the resource.

    """

    # Create a mapping from Model property names to API property names
    _names = {
        "order_id": 'order_id',
        "authorization_id": 'authorization_id',
        "capture_id": 'capture_id'
    }

    _optionals = [
        'order_id',
        'authorization_id',
        'capture_id',
    ]

    def __init__(self,
                 order_id=APIHelper.SKIP,
                 authorization_id=APIHelper.SKIP,
                 capture_id=APIHelper.SKIP):
        """Constructor for the RelatedIdentifiers class"""

        # Initialize members of the class
        if order_id is not APIHelper.SKIP:
            self.order_id = order_id 
        if authorization_id is not APIHelper.SKIP:
            self.authorization_id = authorization_id 
        if capture_id is not APIHelper.SKIP:
            self.capture_id = capture_id 

    @classmethod
    def from_dictionary(cls,
                        dictionary):
        """Creates an instance of this model from a dictionary

        Args:
            dictionary (dictionary): A dictionary representation of the object
            as obtained from the deserialization of the server's response. The
            keys MUST match property names in the API description.

        Returns:
            object: An instance of this structure class.

        """

        if not isinstance(dictionary, dict) or dictionary is None:
            return None

        # Extract variables from the dictionary
        order_id = dictionary.get("order_id") if dictionary.get("order_id") else APIHelper.SKIP
        authorization_id = dictionary.get("authorization_id") if dictionary.get("authorization_id") else APIHelper.SKIP
        capture_id = dictionary.get("capture_id") if dictionary.get("capture_id") else APIHelper.SKIP
        # Return an object of this model
        return cls(order_id,
                   authorization_id,
                   capture_id)

    def __repr__(self):
        return (f'{self.__class__.__name__}('
                f'order_id={(self.order_id if hasattr(self, "order_id") else None)!r}, '
                f'authorization_id={(self.authorization_id if hasattr(self, "authorization_id") else None)!r}, '
                f'capture_id={(self.capture_id if hasattr(self, "capture_id") else None)!r})')

    def __str__(self):
        return (f'{self.__class__.__name__}('
                f'order_id={(self.order_id if hasattr(self, "order_id") else None)!s}, '
                f'authorization_id={(self.authorization_id if hasattr(self, "authorization_id") else None)!s}, '
                f'capture_id={(self.capture_id if hasattr(self, "capture_id") else None)!s})')
